/**
 * Default exports
 * @module default
 */
'use strict'

const contexts = require('./contexts')
const create = require('./create')
const helpers = require('./helpers')
const inject = require('./inject')
const TheHandle = require('./TheHandle')

const lib = create.bind(create)

// `module.exports` overrides these `exports.*`, but still needs them for lebab (https://github.com/lebab/lebab)
exports.contexts = contexts
exports.create = create
exports.TheHandle = TheHandle
exports.inject = inject

module.exports = Object.assign(lib, {
  TheHandle,
  contexts,
  create,
  helpers,
  inject,
})
